package com.cheug.dao.ipml;

import java.sql.Connection;

import java.sql.PreparedStatement;
import java.sql.ResultSet;

import com.cheug.dao.IUserDao;
import com.cheug.domain.User;
import com.cheug.utils.DBUtils;

public class UserDaoImpl implements IUserDao{

	@Override
	public void insert(User user) {
		// JDBC
		Connection conn = null;
		PreparedStatement ps = null;
		
		try {
			//עȡconnection
			conn = DBUtils.getConnection();
			//ʽSQLȡstatement
			String sql = "INSERT into c_user(username,password,email,birthday) VALUES(?,?,?,?)";
			ps = conn.prepareStatement(sql);
			//sql
			ps.setString(1, user.getUsername());
			ps.setString(2, user.getPassword());
			ps.setString(3, user.getEmail());
			ps.setDate(4, new java.sql.Date(user.getBirthday().getTime()));
			//ִsql
			int r = ps.executeUpdate();
			System.out.println("Ӱ:" + r);
		} catch (Exception e) {
			e.printStackTrace();
		}finally {
			DBUtils.dbClose(null, ps, conn);
		}
	}

	@Override
	public User findUser(String username,String password) {
		User user = null;
		// JDBC
		Connection conn = null;
		PreparedStatement ps = null;
		ResultSet rs = null;
		try {
			//עȡconnection
			conn = DBUtils.getConnection();
			//sqlѯ
			String sql = "select * from c_user where username=? and password=?";
			ps = conn.prepareStatement(sql);
			ps.setString(1, username);
			ps.setString(2, password);
			//ִsql
			rs = ps.executeQuery();
			//
			while(rs.next()) {
				user = new User();
				user.setId(rs.getInt("id"));
				user.setUsername(rs.getString("username"));
				user.setPassword(rs.getString("password"));
				user.setEmail(rs.getString("email"));
				user.setBirthday(rs.getDate("birthday"));
			}
		} catch (Exception e) {
			e.printStackTrace();
		}finally {
			DBUtils.dbClose(rs, ps, conn);
		}
		return user;
	}

	@Override
	public User findUser(String username) {
		User user = null;
		// JDBC
		Connection conn = null;
		PreparedStatement ps = null;
		ResultSet rs = null;
		try {
			//עȡconnection
			conn = DBUtils.getConnection();
			//sqlѯ
			String sql = "select * from c_user where username=?";
			ps = conn.prepareStatement(sql);
			ps.setString(1, username);
			//ִsql
			rs = ps.executeQuery();
			//
			while(rs.next()) {
				user = new User();
				user.setId(rs.getInt("id"));
				user.setUsername(rs.getString("username"));
				user.setPassword(rs.getString("password"));
				user.setEmail(rs.getString("email"));
				user.setBirthday(rs.getDate("birthday"));
			}
		} catch (Exception e) {
			e.printStackTrace();
		}finally {
			DBUtils.dbClose(rs, ps, conn);
		}
		return user;
	}

//	public static void main(String[] args) {
//		IUserDao userdao = new UserDaoImpl();
			//
//		User user = new User();
//		user.setUsername("test1");
//		user.setPassword("123");
//		user.setEmail("vip@qq.com");
//		user.setBirthday(new java.util.Date());
//		userdao.insert(user);
			//ѯ
//		User user = userdao.findUser("test1", "1233");
//		System.out.println(user);
//	}
}
